function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect, useRef } from 'react';
import { useAsyncRenderer } from '../asyncRegistry';

const IFrame = props => {
  const {
    waitFor
  } = useAsyncRenderer();
  const {
    src,
    onError,
    onLoad
  } = props;
  const errorRef = useRef();
  const loadRef = useRef();

  function handleLoad() {
    loadRef.current();
    if (onLoad) onLoad();
  }

  function handleError(err) {
    if (errorRef.current) errorRef.current(new Error(`IFrame failed to load ${src}`));
    if (onError) onError(err);
  }

  useEffect(() => {
    waitFor(new Promise((resolve, reject) => {
      errorRef.current = reject;
      loadRef.current = resolve;
    }));
  }, [src, waitFor]); // eslint-disable-next-line jsx-a11y/iframe-has-title,react/jsx-props-no-spreading

  return /*#__PURE__*/React.createElement("iframe", _extends({}, props, {
    onError: handleError,
    onLoad: handleLoad
  }));
};

export default IFrame;