function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { useVideo } from '../contexts';
import ImageInternal from './ImageInternal';

const Image = props => {
  const {
    isPuppeteer,
    getProxiedAssetUrl
  } = useVideo();
  const {
    src,
    ...rest
  } = props;

  if (isPuppeteer) {
    // eslint-disable-next-line react/jsx-props-no-spreading
    return /*#__PURE__*/React.createElement(ImageInternal, _extends({}, props, {
      _originalSrc: src
    }));
  }

  const srcProxied = getProxiedAssetUrl(src); // eslint-disable-next-line react/jsx-props-no-spreading

  return /*#__PURE__*/React.createElement(ImageInternal, _extends({}, rest, {
    src: srcProxied,
    _originalSrc: src
  }));
};

export default Image;