function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect, useRef } from 'react';
import { useAsyncRenderer } from '../asyncRegistry';

const ImageInternal = props => {
  const {
    waitFor
  } = useAsyncRenderer();
  const {
    src,
    _originalSrc,
    onError,
    onLoad,
    ...rest
  } = props;
  const errorRef = useRef();
  const loadRef = useRef();

  function handleLoad() {
    if (loadRef.current) loadRef.current();
    if (onLoad) onLoad();
  }

  function handleError(err) {
    if (errorRef.current) errorRef.current(new Error(`Image failed to load ${_originalSrc}`));
    if (onError) onError(err);
  }

  useEffect(() => {
    waitFor(new Promise((resolve, reject) => {
      errorRef.current = reject;
      loadRef.current = resolve;
    }));
  }, [src, waitFor]); // eslint-disable-next-line jsx-a11y/iframe-has-title,jsx-a11y/alt-text,react/jsx-props-no-spreading

  return /*#__PURE__*/React.createElement("img", _extends({}, rest, {
    src: src,
    onError: handleError,
    onLoad: handleLoad
  }));
};

export default ImageInternal;