function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import FFmpegVideo from './FFmpegVideo';
import HTML5Video from './HTML5Video';
import { useVideo } from '../contexts';

const Video = props => {
  const {
    src,
    htmlSrc,
    ...rest
  } = props;
  const {
    videoComponentType,
    isPuppeteer,
    getProxiedAssetUrl
  } = useVideo();

  if (videoComponentType === 'html') {
    // eslint-disable-next-line react/jsx-props-no-spreading
    if (htmlSrc) return /*#__PURE__*/React.createElement(HTML5Video, _extends({}, rest, {
      src: htmlSrc
    })); // If not puppeteer, proxy file:// URI through server as browser cannot handle file://

    const srcProxied = isPuppeteer ? src : getProxiedAssetUrl(src); // eslint-disable-next-line react/jsx-props-no-spreading

    return /*#__PURE__*/React.createElement(HTML5Video, _extends({}, rest, {
      src: srcProxied
    }));
  }

  if (videoComponentType === 'ffmpeg') {
    // eslint-disable-next-line react/jsx-props-no-spreading
    return /*#__PURE__*/React.createElement(FFmpegVideo, _extends({}, rest, {
      src: src
    }));
  }

  throw new Error(`Invalid videoComponentType ${videoComponentType}`);
};

export default Video;